(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: display_quantity_types_spec.mli,v 1.13 2017/11/07 20:57:41 fclement Exp $ *)

(** {3 Display quantity types specification} *)

open Display_types;;

module type MAKER =
  functor (Scal : Scalar_spec.SCALAR) ->
  functor (Comps : Components_spec.COMPONENTS) ->
sig
  type scalar = Scal.t;;
  type 'a components = 'a Comps.t;;

  type pixmaps = pixmap components
  and lower_left_corners = lower_left_corner components
  ;;

  type print_pixmaps = print_pixmap components
  and scalar_alter_pixmaps = scalar alter_pixmap components
  and draw_pixmaps = draw_pixmap components
  ;;

  type display_quantity =
    {
     print_pixmaps : print_pixmaps;
     alter_pixmaps : scalar_alter_pixmaps;
     draw_pixmaps : draw_pixmaps;
    }
  ;;

  type display_quantities =
    {
     dq_param : display_quantity;
     dq_grad : display_quantity;
    }
  ;;
end
;;
