(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: options.mli,v 1.31 2017/11/13 12:40:11 fclement Exp $ *)

(** {6 Algorithm configuration} *)

open Options_types;;

val get_option_external_program_command :
  unit -> option_external_program_command
;;

val phase_dimension : Ucommand_option.phase_name;;
val get_option_dimension : unit -> option_dimension;;

val get_option_dimension_management : unit -> option_dimension_management;;

val get_option_refinement_strategy : unit -> option_refinement_strategy;;
val get_option_number_of_cuts : unit -> option_number_of_cuts;;
val get_option_basic_refinement_families :
  unit -> option_basic_refinement_families
;;

val get_option_candidate_refinements_selection_criterion_ratio :
  unit -> option_candidate_refinements_selection_criterion_ratio
;;
val get_option_candidate_refinements_selection_criterion_maximum_number :
  unit -> option_candidate_refinements_selection_criterion_maximum_number
;;

val get_option_min_relative_gradients_norm :
  unit -> option_min_relative_gradients_norm
;;
val get_option_min_relative_best_scalar_indicator :
  unit -> option_min_relative_best_scalar_indicator
;;

val get_option_min_relative_scalar_cost_decrease :
  unit -> option_min_relative_scalar_cost_decrease
;;
val get_option_max_iteration : unit -> option_max_iteration;;

(** {6 Program configuration} *)

val get_option_out_formatter : unit -> option_out_formatter;;

val get_option_report_allocated_memory :
  unit -> option_report_allocated_memory
;;

val get_option_incremental_mode : unit -> option_incremental_mode;;

val get_option_graphics_mode : unit -> option_graphics_mode;;

val get_option_graphics_window_min_width :
  unit -> option_graphics_window_min_width
;;
val get_option_graphics_window_max_width :
  unit -> option_graphics_window_max_width
;;
val get_option_graphics_window_min_height :
  unit -> option_graphics_window_min_height
;;
val get_option_graphics_window_max_height :
  unit -> option_graphics_window_max_height
;;

val get_option_graphics_window_background_color :
  unit -> option_graphics_window_background_color
;;

val get_option_graphics_parameter_color_scale_name :
  unit -> option_graphics_color_scale_name
;;

val get_option_graphics_parameter_min :
  unit -> option_graphics_parameter_min
;;

val get_option_graphics_parameter_max :
  unit -> option_graphics_parameter_max
;;

val get_option_graphics_gradient_color_scale_name :
  unit -> option_graphics_color_scale_name
;;

val get_option_graphics_gradient_amplitude :
  unit -> option_graphics_gradient_amplitude
;;

(** {6 Report/debug flags and warning/error messages} *)

val printing_facilities : Udebug.printing_facilities;;
