(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: refinement_spec.mli,v 1.33 2017/11/07 20:57:41 fclement Exp $ *)

(** {3 Refinement specification}
 See description of the algorithm in the outline of Ref-indic. *)

module type MAKER =
  functor (Scal : Scalar_spec.SCALAR) ->
  functor (Comps : Components_spec.COMPONENTS) ->
sig
  module Bb : module type of (Black_box.Make (Scal) (Comps));;

  val compute_exact_indicator_on_selected_refinements :
    Bb.state -> Bb.partitions list -> Bb.selected_refinement list
  ;;

  val algorithm :
    (Bb.state -> Bb.partitions list -> Bb.selected_refinement list) -> unit
  ;;
end
;;
