(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: wrapper_types.mli,v 1.9 2017/10/26 15:09:05 fclement Exp $ *)

open Optimization_status_types;;
open Wire_types;;

type init_in = dimension
and init_out = size * masked_partition * optim_out

and grad_in = fine_parameter
and grad_out = fine_gradient

and optim_in = partition * coarse_parameter
and optim_out = optimization_status * coarse_parameter * cost

and final_in = fine_parameter
and final_out = unit
;;
