(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

open Optimization_status_types_print;;

open Wire_types_print;;

let rec printer_init_in ctx ppf = function | d -> printer_dimension ctx ppf d

and printer_init_out ctx ppf = function
  | (s, m, o) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_size Og_precedence.Ck_tuple_item ppf s;
    Format.fprintf ppf "%,,@ ";
    printer_masked_partition Og_precedence.Ck_tuple_item ppf m;
    Format.fprintf ppf "%,,@ ";
    printer_optim_out Og_precedence.Ck_tuple_item ppf o;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_grad_in ctx ppf = function
  | f -> printer_fine_parameter ctx ppf f

and printer_grad_out ctx ppf = function
  | f -> printer_fine_gradient ctx ppf f

and printer_optim_in ctx ppf = function
  | (p, c) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_partition Og_precedence.Ck_tuple_item ppf p;
    Format.fprintf ppf "%,,@ ";
    printer_coarse_parameter Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_optim_out ctx ppf = function
  | (o, c, c0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_optimization_status Og_precedence.Ck_tuple_item ppf o;
    Format.fprintf ppf "%,,@ ";
    printer_coarse_parameter Og_precedence.Ck_tuple_item ppf c;
    Format.fprintf ppf "%,,@ ";
    printer_cost Og_precedence.Ck_tuple_item ppf c0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"

and printer_final_in ctx ppf = function
  | f -> printer_fine_parameter ctx ppf f

and printer_final_out ctx ppf = function
  | u -> Og_printer.printer_Unit ctx ppf u
;;

(* Defining top printers. *)

let print_init_in ppf = printer_init_in Og_precedence.Ck_toplevel ppf

and print_init_out ppf = printer_init_out Og_precedence.Ck_toplevel ppf

and print_grad_in ppf = printer_grad_in Og_precedence.Ck_toplevel ppf

and print_grad_out ppf = printer_grad_out Og_precedence.Ck_toplevel ppf

and print_optim_in ppf = printer_optim_in Og_precedence.Ck_toplevel ppf

and print_optim_out ppf = printer_optim_out Og_precedence.Ck_toplevel ppf

and print_final_in ppf = printer_final_in Og_precedence.Ck_toplevel ppf

and print_final_out ppf = printer_final_out Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
